      PROGRAM sigmaModel
      INTEGER T,L,N
      PARAMETER (T=10,L=10,N=T*L)
      REAL*8 sigma0(N), sigma1(N), sigma2(N)
      REAL*8 sigma0Sum, sigma1Sum, sigma2Sum
      REAL*8 beta, deltaS
      REAL*8 sigma0Trial,sigma1Trial,sigma2Trial
      INTEGER neighborN(N), neighborW(N), neighborS(N), neighborE(N)
      INTEGER accept, reject

      COMMON sigma0, sigma1, sigma2, sigma0Sum, sigma1Sum, sigma2Sum,
     $     beta, deltaS, sigma0Trial,sigma1Trial,sigma2Trial, neighborN,
     $     neighborW, neighborS, neighborE, accept, reject

      INTEGER equi,sweeps,s
      REAL*8 meanLink, link, measureLinkEnergy
      CALL initSigma()
      equi=1000
      sweeps=1000
      meanLink=0

      CALL metropolisUpdate(equi,4)
      DO 10, s=1,sweeps
         CALL metropolisUpdate(1,4)
         link=measureLinkEnergy()
         meanLink=meanLink+link
 10   CONTINUE
      meanLink = meanLink/sweeps
      PRINT *,'mean=',meanLink
      PRINT *,'ratio=',accept/REAL(accept+reject)

      END

      INTEGER FUNCTION ndx(it,ix)
      INTEGER it,ix
      INTEGER T,L,N
      PARAMETER (T=10,L=10,N=T*L)
      REAL*8 sigma0(N), sigma1(N), sigma2(N)
      REAL*8 sigma0Sum, sigma1Sum, sigma2Sum
      REAL*8 beta, deltaS
      REAL*8 sigma0Trial,sigma1Trial,sigma2Trial
      INTEGER neighborN(N), neighborW(N), neighborS(N), neighborE(N)
      INTEGER accept, reject

      COMMON sigma0, sigma1, sigma2, sigma0Sum, sigma1Sum, sigma2Sum,
     $     beta, deltaS, sigma0Trial,sigma1Trial,sigma2Trial, neighborN,
     $     neighborW, neighborS, neighborE, accept, reject

      ndx= L*(it-1)+ix
      RETURN
      END

      SUBROUTINE randomize3(s0,s1,s2)
      REAL*8 s0,s1,s2
      INTEGER T,L,N
      PARAMETER (T=10,L=10,N=T*L)
      REAL*8 sigma0(N), sigma1(N), sigma2(N)
      REAL*8 sigma0Sum, sigma1Sum, sigma2Sum
      REAL*8 beta, deltaS, drand48,r
      REAL*8 sigma0Trial,sigma1Trial,sigma2Trial
      INTEGER neighborN(N), neighborW(N), neighborS(N), neighborE(N)
      INTEGER accept, reject
      
      COMMON sigma0, sigma1, sigma2, sigma0Sum, sigma1Sum, sigma2Sum,
     $     beta, deltaS, sigma0Trial,sigma1Trial,sigma2Trial, neighborN,
     $     neighborW, neighborS, neighborE, accept, reject

      EXTERNAL drand48

 10   s0=2.0*drand48()-1.0
      s1=2.0*drand48()-1.0
      s2=2.0*drand48()-1.0
      r=s0*s0+s1*s1+s2*s2
      IF (r .GT. 1.0 .OR. r .EQ. 0) GOTO 10
      r=sqrt(r)
      s0 = s0/r
      s1 = s1/r
      s2 = s2/r
      END

      SUBROUTINE initSigma()
      INTEGER T,L,N
      PARAMETER (T=10,L=10,N=T*L)
      REAL*8 sigma0(N), sigma1(N), sigma2(N)
      REAL*8 sigma0Sum, sigma1Sum, sigma2Sum
      REAL*8 beta, deltaS
      REAL*8 sigma0Trial,sigma1Trial,sigma2Trial
      INTEGER neighborN(N), neighborW(N), neighborS(N), neighborE(N)
      INTEGER accept, reject

      COMMON sigma0, sigma1, sigma2, sigma0Sum, sigma1Sum, sigma2Sum,
     $     beta, deltaS, sigma0Trial,sigma1Trial,sigma2Trial, neighborN,
     $     neighborW, neighborS, neighborE, accept, reject

      INTEGER i, it, ix, itup, itdown, ixup, ixdown,ndx
                                                                        
      accept=0
      reject=0
      beta=1.0
      
      DO 10, it=1,T
         DO 20, ix=1,L
            i = ndx(it,ix)
            CALL randomize3(sigma0(i),sigma1(i),sigma2(i))
            
d            itup = (it+1) - ((it+1)/T)*T
d            itdown = (it-1+T)-((it-1+T)/T)*T
d            ixup = (ix+1)-((ix+1)/L)*L
d            ixdown = (ix-1+L)-((ix-1+L)/L)*L

            itup = mod(it-1+1,T)+1
            itdown = mod(it-1-1+T,T)+1
            ixup = mod(ix-1+1,L)+1
            ixdown = mod(ix-1-1+L,L)+1
            
            neighborE(i)=ndx(itup,ix)
            neighborN(i)=ndx(it,ixup)
            neighborW(i)=ndx(itdown,ix)
            neighborS(i)=ndx(it,ixdown)
 20      CONTINUE
 10   CONTINUE
C      CALL srand(4711)
      END
      
      SUBROUTINE sumNeighbors(i)
      INTEGER i,iE,iN,iW,iS
      INTEGER T,L,N
      PARAMETER (T=10,L=10,N=T*L)
      REAL*8 sigma0(N), sigma1(N), sigma2(N)
      REAL*8 sigma0Sum, sigma1Sum, sigma2Sum
      REAL*8 beta, deltaS
      REAL*8 sigma0Trial,sigma1Trial,sigma2Trial
      INTEGER neighborN(N), neighborW(N), neighborS(N), neighborE(N)
      INTEGER accept, reject

      COMMON sigma0, sigma1, sigma2, sigma0Sum, sigma1Sum, sigma2Sum,
     $     beta, deltaS, sigma0Trial,sigma1Trial,sigma2Trial, neighborN,
     $     neighborW, neighborS, neighborE, accept, reject

      
      iE = neighborE(i)		
      iN = neighborN(i)		
      iW = neighborW(i)		
      iS = neighborS(i)		
      
      sigma0Sum=sigma0(iE)+sigma0(iN)+sigma0(iW)+sigma0(iS)
      sigma1Sum=sigma1(iE)+sigma1(iN)+sigma1(iW)+sigma1(iS)
      sigma2Sum=sigma2(iE)+sigma2(iN)+sigma2(iW)+sigma2(iS)
      END
      
      

      
      SUBROUTINE localMetropolisUpdate(i, hits)
      INTEGER i,h,hits 
      INTEGER T,L,N
      PARAMETER (T=10,L=10,N=T*L)
      REAL*8 sigma0(N), sigma1(N), sigma2(N)
      REAL*8 sigma0Sum, sigma1Sum, sigma2Sum
      REAL*8 beta, deltaS,drand48
      REAL*8 sigma0Trial,sigma1Trial,sigma2Trial
      INTEGER neighborN(N), neighborW(N), neighborS(N), neighborE(N)
      INTEGER accept, reject

      COMMON sigma0, sigma1, sigma2, sigma0Sum, sigma1Sum, sigma2Sum,
     $     beta, deltaS, sigma0Trial,sigma1Trial,sigma2Trial, neighborN,
     $     neighborW, neighborS, neighborE, accept, reject

      EXTERNAL drand48

      CALL sumNeighbors(i)

      DO 10,h=1,hits
         CALL randomize3(sigma0Trial,sigma1Trial,sigma2Trial)

         deltaS = -beta * ((sigma0Trial-sigma0(i))*sigma0Sum+
     $        (sigma1Trial-sigma1(i))*sigma1Sum+
     $        (sigma2Trial-sigma2(i))*sigma2Sum)

         IF (deltaS .LT. 0 .OR. drand48() .LT.  exp(-deltaS)) THEN
            sigma0(i)=sigma0Trial
            sigma1(i)=sigma1Trial
            sigma2(i)=sigma2Trial
            accept=accept+1
         ELSE
            reject=reject+1
         ENDIF
 10   CONTINUE
      END


      SUBROUTINE metropolisUpdate(sweeps, hits)
      INTEGER  i, sweeps,hits,s
      INTEGER T,L,N
      PARAMETER (T=10,L=10,N=T*L)
      REAL*8 sigma0(N), sigma1(N), sigma2(N)
      REAL*8 sigma0Sum, sigma1Sum, sigma2Sum
      REAL*8 beta, deltaS
      REAL*8 sigma0Trial,sigma1Trial,sigma2Trial
      INTEGER neighborN(N), neighborW(N), neighborS(N), neighborE(N)
      INTEGER accept, reject

      COMMON sigma0, sigma1, sigma2, sigma0Sum, sigma1Sum, sigma2Sum,
     $     beta, deltaS, sigma0Trial,sigma1Trial,sigma2Trial, neighborN,
     $     neighborW, neighborS, neighborE, accept, reject


      DO 10,s=1,sweeps
         DO 20, i=1,N
            CALL localMetropolisUpdate(i,hits)
 20      CONTINUE
 10   CONTINUE
      END


      REAL*8 FUNCTION measureLinkEnergy()
      INTEGER T,L,N
      PARAMETER (T=10,L=10,N=T*L)
      REAL*8 sigma0(N), sigma1(N), sigma2(N)
      REAL*8 sigma0Sum, sigma1Sum, sigma2Sum
      REAL*8 beta, deltaS,link
      REAL*8 sigma0Trial,sigma1Trial,sigma2Trial
      INTEGER neighborN(N), neighborW(N), neighborS(N), neighborE(N)
      INTEGER accept, reject, ndx

      COMMON sigma0, sigma1, sigma2, sigma0Sum, sigma1Sum, sigma2Sum,
     $     beta, deltaS, sigma0Trial,sigma1Trial,sigma2Trial, neighborN,
     $     neighborW, neighborS, neighborE, accept, reject

      INTEGER it,ix,i,iE,iN,iW,iS
      link=0

      DO 10,it=1,T
         DO 20,ix=1,L
            i = L*(it-1)+ix
	
            iE = neighborE(i)		
            iN = neighborN(i)		
            iW = neighborW(i)		
            iS = neighborS(i)		
                                                                        
            LINK=link+
     $      sigma0(i)*(sigma0(iE)+sigma0(iN)+sigma0(iW)+sigma0(iS))+
     $      sigma1(i)*(sigma1(iE)+sigma1(iN)+sigma1(iW)+sigma1(iS))+
     $      sigma2(i)*(sigma2(iE)+sigma2(iN)+sigma2(iW)+sigma2(iS))

 20      CONTINUE
 10   CONTINUE
      measureLinkEnergy=link/REAL(N)
      return 
      END

